=== debian/changelog ===
nodejs (4.2.6~dfsg-1ubuntu4.2) xenial-security; urgency=medium

  * SECURITY UPDATE: CRLF injection vulnerability
    - debian/patches/CVE-2016-5325-1.patch: Previously, the reason argument
      passed to ServerResponse#writeHead was not being properly validated. One
      could pass CRLFs which could lead to http response splitting. This
      commit changes the behavior to throw an error in the event any invalid
      characters are included in the reason.
      lib/_http_common.js
      lib/_http_server.js
      test/parallel/test-http-status-reason-invalid-chars.js
    - debian/patches/CVE-2016-5325-2.patch: The certificates in test fixtures
      were set to expire in 999 days since they were generated. That time has
      passed, and they have to be reissued. Bump expiration time to 99999 days
      for all of them to prevent this from happening again in near future.
    - CVE-2016-5325

 -- Mike Salvatore <mike.salvatore@canonical.com>  Wed, 08 Aug 2018 10:16:51 -0400

nodejs (4.2.6~dfsg-1ubuntu4.1) xenial; urgency=medium

  * Recompile to resolve miscompilation on s390x architecture. LP:
    #1572613

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 20 May 2016 04:30:23 +0100

nodejs (4.2.6~dfsg-1ubuntu4) xenial; urgency=medium

  * Cherrypick
    https://github.com/andrewlow/node/commit/1cc5c2dad018880c95c41f23570df350e99e4621
    to unbreak s390x with gcc 5.3.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 03 Feb 2016 22:49:58 +0000

nodejs (4.2.6~dfsg-1ubuntu1) xenial; urgency=medium

  * debian/patches/fix_sslv3_test.patch: properly handle how SSLv3 was
    disabled in openssl.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 22 Jan 2016 11:08:38 -0500

nodejs (4.2.6~dfsg-1) unstable; urgency=medium

  * Imported Upstream version 4.2.6~dfsg

 -- Jérémy Lal <kapouer@melix.org>  Fri, 22 Jan 2016 00:07:37 +0100

nodejs (4.2.5~dfsg-1) unstable; urgency=medium

  * Imported Upstream version 4.2.5~dfsg
  * Remove no_sslv3 patch, fixed upstream
  * Override lintian missing source sh_javascript.min.js, because
    it is already fixed by removal and patch.

 -- Jérémy Lal <kapouer@melix.org>  Thu, 21 Jan 2016 09:38:25 +0100

nodejs (4.2.4~dfsg-2) unstable; urgency=medium

  * tests need gcc to get DEB_HOST_ARCH,
    add build-essential as dependency. (Closes: #809845)
  * Fix install path of non-minified sh_javascript

 -- Jérémy Lal <kapouer@melix.org>  Thu, 14 Jan 2016 09:39:14 +0100

nodejs (4.2.4~dfsg-1) unstable; urgency=medium

  * Imported Upstream version 4.2.4~dfsg
  * Adapt v8 backport to s390 patch
  * Refresh patches

 -- Jérémy Lal <kapouer@melix.org>  Thu, 24 Dec 2015 00:59:49 +0100

nodejs (4.2.3~dfsg-2) unstable; urgency=medium

  * There is no gcc -mfpu vfpv2 flag - the right flag is vfp
  * Use repacksuffix in debian/watch
  * Run tests as autopkgtests as well:
    + add debian/rules check target to run tests using binary package
    + create/remove a HOME for test
    + disable test-process-config because it needs configured tree
    + test-fs-watch does not work in test bed
    + test-force-repl hangs in test bed
  * Set test timeout to 3 seconds
  * Flaky test-regress-GH-746 because it requires stdin

 -- Jérémy Lal <kapouer@melix.org>  Sun, 20 Dec 2015 03:03:50 +0100

nodejs (4.2.3~dfsg-1) unstable; urgency=high

  * Imported Upstream version 4.2.3~dfsg
  * CVE-2015-6764 V8 Out-of-bounds Access Vulnerability
    (Closes: #806385)
  * CVE-2015-8027 Denial of Service Vulnerability
    (Closes: #806385)
  * Patch: openssl -ssl3 fails immediately causing
    test-tls-no-sslv3 failure.

 -- Jérémy Lal <kapouer@melix.org>  Fri, 04 Dec 2015 09:02:50 +0100

nodejs (4.2.2~dfsg-1) unstable; urgency=medium

  * Imported Upstream version 4.2.2~dfsg
  * Huge test timeout for all platforms
  * Update from v8z 4.5 branch
  * Node.js 4.2 is LTS, maintain it in master-4.2, upstream-4.2
    + update gbp.conf
    + lock watch file to 4.2.x
    + update Vcs-Git in debian/control
  * Remove test-domain-with-abort-on-uncaught-exception.diff,
    applied upstream
  * Add trivial autopkgtest (Closes: #802735)

 -- Jérémy Lal <kapouer@melix.org>  Wed, 04 Nov 2015 09:37:24 +0100

nodejs (4.2.1~dfsg-2) unstable; urgency=medium

  * Test ci patch: mark test-cluster-disconnect as flaky on arm

 -- Jérémy Lal <kapouer@melix.org>  Fri, 16 Oct 2015 20:56:02 +0200

nodejs (4.2.1~dfsg-1) unstable; urgency=medium

  * Imported Upstream version 4.2.1~dfsg
  * kfreebsd patch: detect freebsd in tools/utils.py, so
    that tests have correct $system set.
  * test_ci_buildd patch: allow longer timeouts for mips64el

 -- Jérémy Lal <kapouer@melix.org>  Tue, 13 Oct 2015 20:54:13 +0200

nodejs (4.2.0~dfsg-2) unstable; urgency=medium

  * Add arch detection for ppc64 in debian/rules, useful for
    tests configuration.
  * Fix failing test-domain-with-abort-on-uncaught-exception
  * Run flaky tests but don't care
  * Run tests with huge timeout

 -- Jérémy Lal <kapouer@melix.org>  Tue, 13 Oct 2015 12:00:18 +0200

nodejs (4.2.0~dfsg-1) unstable; urgency=medium

  * Imported Upstream Long Term Support version 4.2.0~dfsg
  * Allow test-stdout-close-unref to fail on freebsd too
  * Unapply 1006_arm_fpu.patch, applied upstream
  * Remove gflags from copyright, removed upstream
  * Add copyright for s390 patch
  * Exclude non-dfsg "gutenberg small print" licensed file

 -- Jérémy Lal <kapouer@melix.org>  Tue, 13 Oct 2015 00:23:43 +0200

nodejs (4.1.2~dfsg-5) unstable; urgency=medium

  * test-tick-processor can fail on pp64 and s390x:
    + debian/rules: invoke test runner with --arch option
    + test_ci_buildd.patch: declare that test as flaky on those
      two arches, and fix test runner so $arch can be used.

 -- Jérémy Lal <kapouer@melix.org>  Mon, 12 Oct 2015 18:43:22 +0200

nodejs (4.1.2~dfsg-4) unstable; urgency=medium

  * Update patches to pass tests on respective arches
  * Enable tests

 -- Jérémy Lal <kapouer@melix.org>  Mon, 12 Oct 2015 01:26:08 +0200


