=== debian/tests/control ===
Test-Command: ./debian/rules check
Depends: @, cdbs, python, procps, curl, build-essential
